package comunicacao;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Random;

public class TCPSocket implements ISocket {
	private Socket socket;

	private ObjectOutputStream out;
	private ObjectInputStream in;
	
	private Random random;

	public TCPSocket(Socket socket) throws IOException {
		super();
		this.socket = socket;
		this.out = new ObjectOutputStream(this.socket.getOutputStream());
		this.in = new ObjectInputStream(this.socket.getInputStream());
		this.random = new Random();
	}

	public TCPSocket(InetAddress remoteIP, int remotePort) throws IOException {
		this.socket = new Socket(remoteIP, remotePort);
		this.out = new ObjectOutputStream(this.socket.getOutputStream());
		this.in = new ObjectInputStream(this.socket.getInputStream());
		this.random = new Random();
	}

	@Override
	public void sendObject(Serializable object) throws IOException {
		out.writeObject(object);
		out.flush();
	}

	@Override
	public void sendFile(File file) throws IOException {
		byte[] buffer = new byte[2000000];
		FileInputStream fileIn = new FileInputStream(file);
		long fileLength = file.length();
		long aux = 0;
		int read;
		String path = file.getAbsolutePath();
		String fileName = path.substring(path.lastIndexOf('\\') + 1);
		
		
		out.writeLong(fileLength);
		out.writeInt(fileName.length());
		out.write(fileName.getBytes());
		
		while (aux != fileLength){
			read = fileIn.read(buffer);
			aux += read;
			this.out.write(buffer, 0, read);
			System.out.println("Total: " + fileLength  +" Sent: " + aux);
		}
		out.flush();
		fileIn.close();
		

	}

	@Override
	public void sendFile(File file, Object fileState) throws IOException {
		// TODO Auto-generated method stub
		this.sendFile(file);

	}

	@Override
	public Serializable readObject() throws IOException, ClassNotFoundException {
		return (Serializable) in.readObject();
	}

	@Override
	public File readFile() throws IOException {
		FileOutputStream fileOut = null;
		File file;
		long fileLength;
		String fileName;
		int aux = 0, read = 0;
		byte[] buffer = new byte[2000000];
		
		do{
			file = new File("temp\\" + random.nextInt(100) + ".yamtemp");
		} while (file.exists());
		
		
		try {
			fileOut = new FileOutputStream(file, true);
		} catch (FileNotFoundException e) {
			//Won't happen
			e.printStackTrace();
		}
		
		fileLength = in.readLong();
		int len = in.readInt();
		in.readFully(buffer, 0, len);
		fileName = new String(buffer, 0, len);
		System.out.println(fileName);
		
		while (aux != fileLength){
			if (fileLength - aux < buffer.length){
				read = (int) (fileLength - aux);
			} else {
				read = buffer.length;
			}
			
			
			in.readFully(buffer, 0, read);
			aux += read;
			System.out.println("Total: " + fileLength  +" Received: " + aux);
			fileOut.write(buffer, 0, read);
		}
		
		fileOut.close();
		
		File definite = new File("temp\\" + fileName);
		file.renameTo(definite);
		
		return definite;		
	}

	@Override
	public boolean connect() throws IOException {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public void close() throws IOException {
		this.out.close();
		this.in.close();
		this.socket.close();

	}

	@Override
	public InetAddress getRemoteAddress() {
		return this.socket.getInetAddress();
	}

	@Override
	public int getRemotePort() {
		return this.socket.getPort();
	}

}
