package comunicacao.sender;

public class TimeoutAlgorith {
	// Socket timeout calculation variables
	private long estimatedRTT;// Current smoothed estimation of the RTT
	private long devRTT;// Current smoothed deviation of the RTT values
	private long timeout;// Value used as timeout for the segments

	public TimeoutAlgorith() {
		// TODO What value should they have at first?
		this.estimatedRTT = 300;
		this.devRTT = 0;
		this.timeout = 300;
	}
	
	public synchronized void calculateTimeout(long sampleRTT) {
		this.estimatedRTT = ((this.estimatedRTT - (this.estimatedRTT >> 3)) + (sampleRTT >> 3));
		long aux;
		if (sampleRTT > this.estimatedRTT) {
			aux = sampleRTT - this.estimatedRTT;
		} else {
			aux = this.estimatedRTT - sampleRTT;
		}
		this.devRTT = ((this.devRTT - (this.devRTT >> 2)) + (aux >> 2));
		this.timeout = this.estimatedRTT + (this.devRTT << 2);
		System.out.println("New timeout: " + this.timeout);
		// LOG
	}
	
	public synchronized long getTimeout() {
		return this.timeout;
	}

}
