package comunicacao.users;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.SocketException;

import comunicacao.MasterThread;
import comunicacao.Server;
import comunicacao.data.MainBuffer;
import comunicacao.data.segment.Header;
import comunicacao.data.segment.HeaderFlags;
import comunicacao.exception.HeaderDontFitException;

public class UserThread extends Thread{

	private byte[] sendBuffer;
	private MainBuffer receiveBuffer;
	private InetAddress ip;
	private int port;
	private Header synHeader;
	private MainBuffer[] receiveFileBuffers;
	private MainBuffer[] sendFileBuffers;
	private PipedOutputStream source;
	private PipedInputStream sink;
	private DatagramPacket receivedPacket;

	public UserThread(DatagramPacket syn, MainBuffer buffer) {
		this.ip = syn.getAddress();
		this.port = syn.getPort();
		this.synHeader = new Header(syn);
		this.receiveBuffer = buffer;
		this.sink = new PipedInputStream();
		this.source = null;
	}

	

	public void run(){
		String conected = null;
		ObjectInputStream in = null;
		try {
			in = new ObjectInputStream(this.sink);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		for (int i = 0; i < 3 && conected == null; i++) {
			conected = this.sendSynack();
			// TODO ask to a monitor, how many times we should retransmit the SYNACK.
		}

		if(conected != null){
			try {
				this.receivedPacket = (DatagramPacket) in.readObject();
				this.treatPacket(receivedPacket);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {

		}


	}
	
	//TODO terminar esse metodo
	public void treatPacket(DatagramPacket p){
		Header header =  new Header(p);
		if (header.getFlags().isStr()){
			int id = header.getFlags().idValue();
			if (this.receiveFileBuffers[id] == null){
				//TODO NAO EH SEIS, AJEITE
				this.receiveFileBuffers[id] = Server.requestBuffer(6);
			}else {
				//TODO pode usar esse ID nao, jah tem gente usando ele. Avisa pra quem mandou o STR
			}
		
		
		}
		
		
		
	}

	public String sendSynack(){
		String returned = null;
		DatagramPacket synack = new DatagramPacket(sendBuffer, Header.HEADER_SIZE, this.ip, this.port);
		Header header = new Header(new HeaderFlags(true, false, false, true, false, false, 0), this.synHeader.getSeqNum());
		try {
			header.putHeader(sendBuffer);
			MasterThread.getServerSocketInstance().send(synack);

			try {
				this.sleep(3000);
				returned = null;
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				// The ack has arrived
				e.printStackTrace();
				// The ackData will come from the masterThread
				returned = new String(this.receiveBuffer.getByteBuffer(), Header.HEADER_SIZE, this.receiveBuffer.getLength()- Header.HEADER_SIZE);
			}

		} catch (HeaderDontFitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SocketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return returned;

	}

	public OutputStream getOutputStream() throws IOException{
		if (this.source == null){
			this.source = new PipedOutputStream();
			this.source.connect(this.sink);
		}
		
		return this.source;
		
	}
	
	
	public void requestTreatment(String ackData){
		String filePath = null;
		if(ackData != null){
			if(ackData.contains("UPLOAD\n\n")){
				filePath = ackData.substring(8);				
				Header header = new Header(this.receiveBuffer.getByteBuffer());

			}
		}
	}
}

