package comunicacao.util;

import java.io.Serializable;

public class UnsignedInteger implements Serializable {
	private int value;
	
	
	public UnsignedInteger(long unsignedValue){
		this.setValue(unsignedValue);		
	}
	
	public long value(){
		long returnMe = (this.value  + 2147483648L);
		return returnMe;
	}
	
	public int getSignedValue(){
		return this.value;
	}
	
	public void directlySetValue(int value){
		this.value = value;
	}
	
	public void setValue(long unsignedValue){
		if (unsignedValue < 0 || unsignedValue > 4294967295L){
			throw new IllegalArgumentException("value " + unsignedValue + " is not a positive 32 bit number");
		}
		
		this.value = (int) (Integer.MIN_VALUE + unsignedValue);
		
		
	}
	
	public void add(int value){
		this.value += value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + value;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UnsignedInteger other = (UnsignedInteger) obj;
		if (value != other.value)
			return false;
		return true;
	}
	
	
}
