package core;
import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import comunicacao.IServerSocket;
import comunicacao.TCPServerSocket;

public class ServerComunication extends Thread {

	private ArrayList<ActionServer> threadUser;

	public ServerComunication() throws IOException, ClassNotFoundException {
		super();
		threadUser = new ArrayList<ActionServer>();
	}
	public void run(){
		try {
			listenConection();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void listenConection() throws IOException, ClassNotFoundException {
		IServerSocket serverSocket = new TCPServerSocket(2000);
		ExecutorService server = Executors.newCachedThreadPool();
		while (true) {
			ActionServer actions = new ActionServer(serverSocket.accept());
			threadUser.add(actions);
			server.submit(actions);
		}
	}

	public ArrayList<InformationServerUser> getInformationServerUsers() {
		ArrayList<InformationServerUser> array = new ArrayList<InformationServerUser>();
		for (int i = 0; i < this.threadUser.size(); i++) {
			System.out.println(threadUser.get(i).getUser()+"    "+threadUser.get(i).isActive());
			if (threadUser.get(i).isActive()) {
				if (threadUser.get(i).getUser() != null) {
					array.add(new InformationServerUser(threadUser.get(i)
							.getUser(), threadUser.get(i).getSocket()
							.getRemoteAddress().getHostAddress(), true));
				}
			} else {
				threadUser.remove(i);
			}
		}
		return array;
	}

	public String[] getAllUsers() {
		return ActionServer.getAllUsers();
	}

	public ArrayList<InformationCliente> getInformationClientes() {
		ArrayList<InformationCliente> informationClientes = new ArrayList<InformationCliente>();
		for (ActionServer action : threadUser) {
			if (action.isActive()) {
				if (action.getUser() != null) {
					informationClientes.addAll(action.getInformationClientes());
				}
			}
		}
		return informationClientes;
	}

}
